/*                  Part of x2grbl
 *
 *  Copyright Johann Wilhelm <johann.wilhelm@9mal6.de> 2015
 *
 *  see Readme.md for detailed license and usage information!
*/

#ifndef AUTOLEVELPROXY_H
#define AUTOLEVELPROXY_H

#include <gcodeoutputdevice.h>

class AutoLevelProxy : public GCodeOutputDevice
{
public:
    AutoLevelProxy(QObject *parent=0);
    ~AutoLevelProxy();

    virtual bool supported(GCode &Cmd);
    virtual bool Run(GCode &Cmd);
    virtual QString name();
    virtual void Reset();

    void setOutputDevice(GCodeOutputDevice &Device);

    void ProbeGrid(double minX, double maxX, double minY, double maxY);

    double loopupHeight(double x, double y, double originalZ, double adjust);

protected:
    GCodeOutputDevice *device;

    double x;
    double y;
    double z;

    double highZ;
    double millingDepth;
    double probingGrid;
    bool rapidMotionForSeeking;

    int minXGrid;
    int maxXGrid;
    int minYGrid;
    int maxYGrid;

    double millingSpeed;
    double rapidSpeed;
    bool changeG1toG0forRapid;

    double *gridData;
    int numGridDataPoints;
};
#endif // AUTOLEVELPROXY_H
