/*                  Part of x2grbl
 *
 *  Copyright Johann Wilhelm <johann.wilhelm@9mal6.de> 2015
 *
 *  see Readme.md for detailed license and usage information!
*/

#ifndef TRANSFERQUEUE_H
#define TRANSFERQUEUE_H

#include <QIODevice>
#include <QQueue>

#include <gcodeoutputdevice.h>
#include <gcodeparser.h>
#include <gcodeinterpreter.h>

class TransferQueue
{
public:
    TransferQueue();

    void setOutputDevice(GCodeOutputDevice *Device);
    void addFile(QIODevice *File);

protected:
    GCodeParser Parser;
    GCodeInterpreter Interpreter;
    GCodeOutputDevice *OutputDevice;
    QQueue<QIODevice *> TransferList;
};

#endif // TRANSFERQUEUE_H
